-- <<{THMain} #####################################################################################

---@class THMain
---@field class THMain
---@field isa function
THMain = {}
local THMain_mt = Class(THMain)

testModLua = Mod:init()
local objectRotateIDs = {}

-- <<[Initialization]>> ===========================================================================

-- {new} -----------------------------------------------------------------
-- * creates and returns a new environment
---@param mt? table @custom metatable [**optional**]
---@return THMain?
function THMain.new(mt)
    mt = Utils.getNoNil(mt, THMain_mt)

    ---@class THMain
    local newEnv = setmetatable({}, mt)

    if newEnv ~= nil then -- mod specific variable initialization
        return newEnv
    end
end

function THMain:update(dt)

    -- Récupérer l'heure actuelle du jeu (en heures)
    local currentHour = g_currentMission.environment.currentHour
    for _, id in ipairs(objectRotateIDs) do
        rotateAboutLocalAxis(id, 0.05, 0.3, 1, 0.1)
    end
end

-- <<[Event Functions]>> ==========================================================================

-- {loadMap} -------------------------------------------------------------
-- * added by addModEventListener()
-- * called by BaseMission.loadMapFinished()
---@param filename string @map xml filename
function THMain:loadMap(filename)
end

-- <<{Script Start}>> #############################################################################

---@diagnostic disable-next-line: lowercase-global
g_thMain = THMain.new()

function testModLua.onCreate(id)
    for i=#g_currentMission.placeables, 1, -1 do
        local placeable = g_currentMission.placeables[i]
		table.insert(objectRotateIDs, placeable.currentSavegameId)
        placeable:delete()
    end
	--table.insert(objectRotateIDs, id)
end

if g_thMain ~= nil then
    -- uncomment the line below to active your onCreate callback
    -- you'll need to add your SolorPanel class to this as well for the line below to work
    g_onCreateUtil.addOnCreateFunction("TestModLua", testModLua.onCreate)
    addModEventListener(g_thMain)
end
