testModLua = Mod:init()

--local rotationHour = 8
local leftSolarPanel = {}
local rightSolarPanel = {}
local switchAnim = {}
local switchSide = {}
local targetRot = 0
local minOpen = 0
local lastMinOpen = 0
local currentHour = 0
local lastHour = 0
local hourThisYear = 0

local moneyFromConfig = 0

local changeAnim = false
local changeSide = false

local alreadyOneTransfo = false

farmConfigurations = {}

local farmIDofPlayer = 0

farmId = 1

local farm = 0
local moneyOfTheDay = 0

function testModLua:startMission() 
	--addFarmConfiguration(1, 0, 0) --Ajoute une nouvelle "configuration de farm, en indiquant le farmland, puis le nombre de panneaux solaire, puis le nombres de transfo
	onGameLoaded()
end
function testModLua:update(dt)
	currentHour = g_currentMission.environment.currentHour
	if(lastHour >= 23) then
		if(currentHour < 10) then
			lastHour = currentHour
		end
	end
	if(currentHour > lastHour) then
		lastHour = currentHour
		addMoneyFromSP()--1)
		if(hourThisYear >= 8760) then
			hourThisYear = 0
			minOpen = 0
		end
	end
    --local currentHour = g_currentMission.environment.currentHour
    for _, id in ipairs(leftSolarPanel) do
		if (getName(id) == "TL" or getName(id) == "TR") then
			if(changeAnim == true) then
				testModLua.solarPanelDoorLeft(id)
			else 
				testModLua.solarTrackAnim(id)
			end
		else
			testModLua.removeValue(leftSolarPanel, id)
		end
    end
	for _, id in ipairs(rightSolarPanel) do
		if (getName(id) == "TR" or getName(id) == "TL") then
			if(changeAnim == true) then
				testModLua.solarPanelDoorRight(id)
			else
				testModLua.solarTrackAnim(id)
			end
		else
			testModLua.removeValue(rightSolarPanel, id)
		end
    end
	for _, id in ipairs(switchAnim) do
		if (getName(id) == "BoutonCommande") then
			testModLua.switchPosAnim(id)
		else
			testModLua.removeValue(switchAnim, id)
		end
	end
	for _, id in ipairs(switchSide) do
		if (getName(id) == "Poignee_G") then
			testModLua.switchMod(id)
		else
			testModLua.removeValue(switchSide, id)
		end
	end
end

function testModLua.removeValue(tbl, value)
	if(tbl == switchAnim) then
		alreadyOneTransfo = false
	end
    for i = #tbl, 1, -1 do
        if tbl[i] == value then
            table.remove(tbl, i)
        end
    end
end


function Placeable:finalizePlacement()
	testModLua.new(self.rootNode)
    SpecializationUtil.raiseEvent(self, "onPreFinalizePlacement")
    self:addToPhysics()
    g_currentMission.placeableSystem:addPlaceable(self)
    g_currentMission:addOwnedItem(self)
    self:collectPickObjects(self.rootNode)
    for _, node in pairs(self.pickObjects) do
        g_currentMission:addNodeObject(node, self)
    end
    local x,_,z = getWorldTranslation(self.rootNode)
    self.farmlandId = g_farmlandManager:getFarmlandIdAtWorldPosition(x, z)
	farmIDofPlayer = self.farmlandID
	addObjectToFarmConfig(self.rootNode, self.farmlandId)
    if self.boughtWithFarmland then
        if self.isServer then
            self:updateOwnership()
        end
        g_farmlandManager:addStateChangeListener(self)
    end
    SpecializationUtil.raiseEvent(self, "onFinalizePlacement")
    SpecializationUtil.raiseEvent(self, "onPostFinalizePlacement")
    if self:getNeedWeatherChanged() then
        g_messageCenter:subscribe(MessageType.WEATHER_CHANGED, self.weatherChanged, self)
    end
    if self:getNeedHourChanged() then
        g_messageCenter:subscribe(MessageType.HOUR_CHANGED, self.hourChanged, self)
    end
    if self:getNeedMinuteChanged() then
        g_messageCenter:subscribe(MessageType.MINUTE_CHANGED, self.minuteChanged, self)
    end
    if self:getNeedDayChanged() then
        g_messageCenter:subscribe(MessageType.DAY_CHANGED, self.dayChanged, self)
    end
    g_messageCenter:subscribe(MessageType.PERIOD_CHANGED, self.periodChanged, self)
    g_messageCenter:publish(MessageType.FARM_PROPERTY_CHANGED, self:getOwnerFarmId())
end

-- Appeler la fonction pour afficher tous les placeables lorsque le jeu est prêt
function onGameLoaded()
end

function testModLua.onCreate(id)
	testModLua.new(id)
end

function testModLua.new(id)
	local refName = getName(id)
	if (refName == "animSolar.i3d" or refName == "animSolar5.i3d" or refName == "animSolar10.i3d") then
		setRotation(id, 0, 0, 0)
		id = id + 2 -- Le panneau à un ID = à idroot + 4 panneau en pos -5 (anciennement 0)
		table.insert(leftSolarPanel, id)
		if(refName == "animSolar.i3d") then
			id = id + 8
			setTranslation(id, 0, -100, 0)
			id = id - 8
			id = id + 2 
		elseif(refName == "animSolar5.i3d") then
			id = id + 24
			setTranslation(id, 0, -100, 0)
			id = id - 24
			id = id + 6 
		elseif(refName == "animSolar10.i3d") then
			id = id + 44
			setTranslation(id, 0, -100, 0)
			id = id - 44
			id = id + 11 
		end
		table.insert(rightSolarPanel, id)
	elseif (refName == "animSolar60.i3d" or refName == "animSolar120.i3d") then
		setRotation(id, 0, 0, 0)
		local idAdd = 6
		id = id + 2 
		table.insert(leftSolarPanel, id)
		if(refName == "animSolar120.i3d") then
			idAdd = 11
			id = id + 254
			setTranslation(id, 0, -100, 0)
			id = id - 254
		else
			id = id + 134
			setTranslation(id, 0, -100, 0)
			id = id - 134
		end
		id = id + idAdd  
		table.insert(rightSolarPanel, id)
		id = id + idAdd 
		table.insert(leftSolarPanel, id)
		id = id + idAdd  
		table.insert(rightSolarPanel, id)
		id = id + idAdd  
		table.insert(leftSolarPanel, id)
		id = id + idAdd  
		table.insert(rightSolarPanel, id)
		id = id + idAdd  
		table.insert(rightSolarPanel, id)
		id = id + idAdd 
		table.insert(leftSolarPanel, id)
		id = id + idAdd
		table.insert(rightSolarPanel, id)
		id = id + idAdd
		table.insert(leftSolarPanel, id)
		id = id + idAdd
		table.insert(rightSolarPanel, id)
		id = id + idAdd
		table.insert(leftSolarPanel, id) 
	elseif (refName == "transfoControl.i3d") then
		if(alreadyOneTransfo == false) then
			id = id + 2
			table.insert(switchAnim, id)
			id = id + 1
			table.insert(switchSide, id)
			alreadyOneTransfo = true
		end
	elseif (refName == "solar3D.i3d" or refName == "solar3D5.i3d" or refName == "solar3D10.i3d" or refName == "solar3D60.i3d" or refName == "solar3D120.i3d") then
		setRotation(id, 0, 0, 0)
		id = id + 1
		setTranslation(id, 0, -100, 0)
	end
end

function myObjectOnCreate(id)
	testModLua.onCreate(id)
end

function testModLua.solarTrackAnim(id)
    currentHour = g_currentMission.environment.currentHour
    local xRot, yRot, zRot = getRotation(id)
    zRot = zRot * (180 / math.pi)
    if currentHour == 9 then
        targetRot = -40
    elseif currentHour == 10 then
        targetRot = -30
    elseif currentHour == 11 then
        targetRot = -20
    elseif currentHour == 12 then
        targetRot = -10
    elseif currentHour == 13 then
        targetRot = 0
    elseif currentHour == 14 then
        targetRot = 10
    elseif currentHour == 15 then
        targetRot = 20
    elseif currentHour == 16 then
        targetRot = 30
    elseif currentHour == 17 then
        targetRot = 40
    elseif currentHour == 18 then
        targetRot = 50
    end
    if currentHour >= 8 and currentHour <= 19 then
		if zRot < (targetRot-1) then
			rotateAboutLocalAxis(id, -0.001, 0, 0, -0.1)
		elseif zRot > (targetRot+1) then
			rotateAboutLocalAxis(id, -0.001, 0, 0, 0.1)
		end
    elseif currentHour == 8 and zRot > 50 then -- Ouverture
        rotateAboutLocalAxis(id, -0.001, 0, 0, 0.1)
    elseif currentHour >= 19 and zRot > 0 then -- Fermeture panneau
		targetRot = 0
        rotateAboutLocalAxis(id, -0.0001, 0, 0, 0.1)
    end
end

function testModLua.solarPanelDoorLeft(idLeft)
	if (getName(idLeft) == "TL") then
		local xRot, yRot, zRot = getRotation(idLeft)
		zRot = zRot * (180 / math.pi)
		local targetRot1 = 50
		local direction = -0.1
		if changeSide == true then
			targetRot1 = -50
			direction = 0.1
			if zRot > targetRot1 then
				rotateAboutLocalAxis(idLeft, -0.001, 0, 0, direction)
			end
		else
			if zRot < targetRot1 then
				rotateAboutLocalAxis(idLeft, -0.001, 0, 0, direction)
			end
		end
	end
end
function testModLua.solarPanelDoorRight(idRight)
	if (getName(idRight) == "TR") then
		local xRot2, yRot2, zRot2 = getRotation(idRight)
		zRot2 = zRot2 * (180 / math.pi)
		local targetRot2 = -50
		local direction = 0.1
		if changeSide == true then
			targetRot2 = 50
			direction = -0.1
			if zRot2 < targetRot2 then
				rotateAboutLocalAxis(idRight, -0.001, 0, 0, direction)
			end
		else 
			if zRot2 > targetRot2 then
				rotateAboutLocalAxis(idRight, -0.001, 0, 0, direction)
			end
		end
	end
end

function testModLua.switchPosAnim(id)
	local xRotSwi, yRotSwi, zRotSwi = getRotation(id)
	zRotSwi = zRotSwi * (180 / math.pi)
	if (zRotSwi<100) then 
		changeAnim = true
		if(lastMinOpen ~= g_currentMission.environment.currentMinute) then
			lastMinOpen = g_currentMission.environment.currentMinute
			minOpen = minOpen + 1
			if(minOpen >= 12000) then
				changeAnim = false
			end
		end
	else 
		changeAnim = false
	end
end
function testModLua.switchMod(id)
	local xRotSwi2, yRotSwi2, zRotSwi2 = getRotation(id)
	zRotSwi2 = zRotSwi2 * (180 / math.pi)
	if(zRotSwi2>1) then
		changeSide = false
	else
		changeSide = true
	end
end


-- Fonction pour ajouter une nouvelle configuration de ferme
function addFarmConfiguration(farmID, numOfPanel, numOfTransfo, citern)
    table.insert(farmConfigurations, {
        farmID = farmID,
        numOfPanel = numOfPanel,
        numOfTransfo = numOfTransfo,
		citern = citern
    })
end
function getFarmConfigurationByID(farmID)
    for _, config in ipairs(farmConfigurations) do
        if config.farmID == farmID then
            return config
        end
    end
    return nil -- Retourne nil si la configuration n'est pas trouvée
end

function addObjectToFarmConfig(id, farmlandID)
	if (getName(id) == "solar3D120.i3d" or getName(id) == "solar3D60.i3d" or getName(id) == "citern.i3d" or getName(id) == "animSolar.i3d" or getName(id) == "animSolar5.i3d" or getName(id) == "animSolar10.i3d" or getName(id) == "animSolar60.i3d" or getName(id) == "animSolar120.i3d" or getName(id) == "solar3D.i3d" or getName(id) == "solar3D5.i3d" or getName(id) == "solar3D10.i3d" or getName(id) == "transfoControl.i3d" or getName(id) == "transfoClas.i3d") then
		local objectName = getName(id)
		local config = getFarmConfigurationByID(farmlandID)
		if config then
			if objectName == "animSolar.i3d" then
				config.numOfPanel = config.numOfPanel + 2
			elseif objectName == "animSolar5.i3d" then
				config.numOfPanel = config.numOfPanel + 10
			elseif objectName == "animSolar10.i3d" then
				config.numOfPanel = config.numOfPanel + 20
			elseif objectName == "animSolar60.i3d" then
				config.numOfPanel = config.numOfPanel + 60
			elseif objectName == "animSolar120.i3d" then
				config.numOfPanel = config.numOfPanel + 120
			elseif objectName == "solar3D.i3d" then
				config.numOfPanel = config.numOfPanel + 1
			elseif objectName == "solar3D5.i3d" then
				config.numOfPanel = config.numOfPanel + 5
			elseif objectName == "solar3D10.i3d" then
				config.numOfPanel = config.numOfPanel + 10
			elseif objectName == "solar3D60.i3d" then
				config.numOfPanel = config.numOfPanel + 60
			elseif objectName == "solar3D120.i3d" then
				config.numOfPanel = config.numOfPanel + 120
			elseif objectName == "transfoControl.i3d" then
				config.numOfTransfo = config.numOfTransfo + 1
			elseif objectName == "transfoClas.i3d" then
				config.numOfTransfo = config.numOfTransfo + 1
			elseif objectName == "citern.i3d" then
				config.citern = config.citern + 1
			end
		else
			addFarmConfiguration(farmlandID, 0, 0, 0)
			addObjectToFarmConfig(id, farmlandID)
		end
	end
end

function calculateMoneyForConfiguration(config)
    local numOfTransfo = config.numOfTransfo
    local numOfPanel = config.numOfPanel
	
	if(config.citern ~= nil) then
		if(numOfPanel >= 1) then
			local panelsForCalculation = math.min(numOfPanel, numOfTransfo * 1600)
			moneyFromConfig = panelsForCalculation * 0.1
		end
	else 
		local moneyFromConfig = 0
	end
    return moneyFromConfig
end

function addMoneyFromSP()
    local totalMoney = 0

    for _, config in ipairs(farmConfigurations) do
        moneyFromConfig = calculateMoneyForConfiguration(config)
		totalMoney = totalMoney + moneyFromConfig
		farmId = config.farmID
		--farm = g_farmManager:getFarmById(farmId)
    end
	
	--farmId = 1
	--local farm = g_farmManager:getFarmById(farmId)

    --local balance = farm:getBalance()
	--local amount = balance + totalMoney
	local actualHour = g_currentMission.environment.currentHour
	if actualHour == 23 then 
		totalMoney = moneyOfTheDay
		moneyOfTheDay = 0
		if totalMoney > 0 then
			farm:changeBalance(totalMoney, MoneyType.OTHER)
			g_currentMission:addMoneyChange(totalMoney, farmId, MoneyType.OTHER, true)
		end
	else 
		moneyOfTheDay = moneyOfTheDay + totalMoney
	end
    
end

function Player:onEnter(isControlling)
    self:raiseActive()
    if self.foliageBendingNode ~= nil and self.foliageBendingId == nil and g_currentMission.foliageBendingSystem then
        -- foliage bending
        self.foliageBendingId = g_currentMission.foliageBendingSystem:createRectangle(-0.5, 0.5, -0.5, 0.5, 0.4, self.foliageBendingNode)
    end
    if self.isServer then
        self:setOwner(self.networkInformation.creatorConnection)
    end
    if isControlling or self.isServer then
        self:raiseDirtyFlags(self.networkInformation.dirtyFlag)
    end
    self.isControlled = true
    if isControlling then
        g_messageCenter:subscribe(MessageType.INPUT_BINDINGS_CHANGED, self.onInputBindingsChanged, self)
        g_messageCenter:publish(MessageType.OWN_PLAYER_ENTERED)
        g_currentMission:addPauseListeners(self, Player.onPauseGame)
        setRotation(self.cameraNode, 0, 0, 0)
        setCamera(self.cameraNode)
        self.isEntered = true
        self:setVisibility(false)
        self:registerActionEvents()
        g_currentMission.environmentAreaSystem:setReferenceNode(self.cameraNode)
    else
        self:setVisibility(true)
    end
    self.playerHotspot:setOwnerFarmId(self.farmId)
    g_currentMission:addMapHotspot(self.playerHotspot)
    if self.isServer and not self.isEntered and g_currentMission.trafficSystem ~= nil and g_currentMission.trafficSystem.trafficSystemId ~= 0 then
        addTrafficSystemPlayer(g_currentMission.trafficSystem.trafficSystemId, self.graphicsRootNode)
    end
    self.isTorchActive = false
	
	farm = g_farmManager:getFarmById(self.farmId)
end

-- Ajouter un gestionnaire d'événement pour exécuter la fonction lorsque le jeu est chargé
addModEventListener({ onGameLoaded = onGameLoaded })
g_onCreateUtil.addOnCreateFunction("TestModLua", testModLua.onCreate)
